
#    MIDAS Access Server  for  Quixtream server

global env
source [file join $env(MIDASBASE) TclHttpd tcl MIDASDomainHandler.tcl]       ;#  load default support procedures

global MIDAS_QServer_Verbose
set MIDAS_QServer_Verbose 0

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0

global QuixstreamServer 
set QuixstreamServer "nndhcp232"

global QuixstreamPort
set QuixstreamPort 10



# Use namespaces to isolate your methods
namespace eval urn:QServer {

    proc QServerVerbose {vl} {global MIDAS_QServer_Verbose; set MIDAS_QServer_Verbose $vl; return [rpcvar::rpcvar int 0]}

    proc QServerInit {} {
        global env MIDAS_QServer_Verbose

        if {$MIDAS_QServer_Verbose} \
             {puts "called method QServer::ServerInit"}

        source [file join $env(MIDASBASE) TclHttpd MIDASservices quixtream.tcl]

        set rc [QServer_Init]

        if {$MIDAS_QServer_Verbose}  {puts "QServer reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc QServerExit {} {
        global env MIDAS_QServer_Verbose

        if {$MIDAS_QServer_Verbose} \
             {puts "called method QServer::ServerExit"}

        set rc [QServer_Exit]
             
        if {$MIDAS_QServer_Verbose}  {puts "QServer reply $rc"}

        return [rpcvar::rpcvar int 0]
    }

    proc QServerWrite {Address Count Value} {
        global env MIDAS_QServer_Verbose

        if {$MIDAS_QServer_Verbose} \
             {puts "called method QServer::QServerWrite with parameters $Address $Count $Value"}

        set rc [QServer_Write $Address $Count $Value]

        if {$MIDAS_QServer_Verbose}  {puts "QServer reply $rc"}

        return [rpcvar::rpcvar int 0]
    }

    proc QServerRead {Address Count} {
        global env MIDAS_QServer_Verbose

        if {$MIDAS_QServer_Verbose} \
             {puts "called method QServer::QServerRead with parameters $Address $Count"}

        set rc [QServer_Read $Address $Count]

        if {$MIDAS_QServer_Verbose}  {puts "QServer reply $rc"}

        return [rpcvar::rpcvar string $rc]
    }


    # We have to publish the public methods...

     SOAP::export QServerVerbose
     SOAP::export QServerInit
     SOAP::export QServerWrite
     SOAP::export QServerRead

     
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /QServer -namespace urn:QServer -uri urn:QServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/QServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

